質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.38%

  • Python

    12839questions

    Pythonは、コードの読みやすさが特徴的なプログラミング言語の1つです。 強い型付け、動的型付けに対応しており、後方互換性がないバージョン2系とバージョン3系が使用されています。 商用製品の開発にも無料で使用でき、OSだけでなく仮想環境にも対応。Unicodeによる文字列操作をサポートしているため、日本語処理も標準で可能です。

  • Python 3.x

    10718questions

    Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。

  • PyCharm

    243questions

    エディター・開発ツール

Pythonでgotoを使いたい

解決済

回答 3

投稿

  • 評価
  • クリップ 0
  • VIEW 1,981

pippip

score 22

知りたいこと

Pythonで多重ループを抜けるためにgotoを使いたいのですが、gotoのパッケージをインストールしようとするとPycharmでエラーが出ます。エラー内容は以下の通りです。解決案にPythonのバージョンについて書いているのですが、Pythonのバージョンは悪くないと思うのですが、何をすればgotoを使えるのでしょうか。

実行されたコマンド:
  pip install goto
エラーの発生:
  SyntaxError: invalid syntax
Proposed solution:
  Make sure that you use a version of Python supported by this package. Currently you are using Python 3.6.
Command output:
  Collecting goto
  Downloading https://files.pythonhosted.org/packages/24/b5/12814d5951e82253e9936eccac77c2f058cb2dcee1c4219efef82408df5a/goto-0.1.3.tar.gz
    Complete output from command python setup.py egg_info:
    Traceback (most recent call last):
      File "<string>", line 1, in <module>
      File "C:\Users\proto\AppData\Local\Temp\pycharm-packaging\goto\setup.py", line 3, in <module>
        import goto
      File "C:\Users\proto\AppData\Local\Temp\pycharm-packaging\goto\goto\__init__.py", line 10, in <module>
        from . import goto
      File "C:\Users\proto\AppData\Local\Temp\pycharm-packaging\goto\goto\goto.py", line 86
        print '<<< [%02i] %s %s' % (_req_cnt, 'POST' if post else 'GET', url)
                               ^
    SyntaxError: invalid syntax

    ----------------------------------------

Command "python setup.py egg_info" failed with error code 1 in C:\Users\proto\AppData\Local\Temp\pycharm-packaging\goto\
You are using pip version 10.0.1, however version 18.0 is available.
You should consider upgrading via the 'python -m pip install --upgrade pip' command.
  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 3

checkベストアンサー

+1

ただのWebアクセス用のラッパーみたいですけど中身までちゃんと見てますか?

https://bitbucket.org/imbolc/goto/src/0ac45009189934413f335220ecdd69110a253c38/goto/goto.py#lines-3

'''Goto - urllib object wrapper'''

goto実装はいくつかあるみたいですがバイトコードを書き換えるとかいう手段だったりジョークだったりで、なにかトラブルが出たらそれなりにPythonを知っていても対処できなくなる代物なので、この内容で躓いているようなら手を出しちゃいけないと思います。

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

0

You are using pip version 10.0.1, however version 18.0 is available.

とあるように、Pythonのバージョンではなくてpipのバージョンに対してエラーが出ていますね。
エラーメッセージの指示にあるとおり、

python -m pip install --upgrade pip
と実行してみてはいかがでしょうか。

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

0

gotoを利用したことがないので、詳しいことはわかりませんが、
エラーの内容を見ると、Python2の書式になってるようなので、
利用するPythonを2に下げないと、インストールできなさそうですね。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/09/12 11:23

    "goto for python" であれば、サイトを見ると「It requires Python 2.3 or later.」の記述があるので、2.3で作られてるみたいですね。
    それより「The "goto" module was an April Fool's joke, published on 1st April 2004. Yes, it works, but it's a joke nevertheless. Please don't use it in real code!」の記述が気になりますが……(ジョークだよ、だからリアルな場面でつわないでね)。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.38%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る

  • Python

    12839questions

    Pythonは、コードの読みやすさが特徴的なプログラミング言語の1つです。 強い型付け、動的型付けに対応しており、後方互換性がないバージョン2系とバージョン3系が使用されています。 商用製品の開発にも無料で使用でき、OSだけでなく仮想環境にも対応。Unicodeによる文字列操作をサポートしているため、日本語処理も標準で可能です。

  • Python 3.x

    10718questions

    Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。

  • PyCharm

    243questions

    エディター・開発ツール